<template lang="pug">
  .photo-editor.no-select(:class="{ mobile: isMobile }")
    .art-board(
      :style="artBoardStyle"
      ref="artBoard"
    )
      tools(
        @mobile-menu-click="showMobileMenu = !showMobileMenu"
        @add-clicked="showActionContent = true"
        ref="tools"
      )
      .workspace(
        :style="workspaceStyle"
        ref="workspace"
      )
        toolbar(ref="toolbar")
        text-tools(
          @color-picker-clicked="textColorPickerShown = !textColorPickerShown"
          :isSmall="isMobile"
          ref="textTools"
        )
        ai(ref="ai")
        .upload-overlay(
          v-if="isFileDragged"
          :style="{width: overlay.width, height: overlay.height}"
        )
          .upload-overlay-inner
            .icon-wrapper
              .icon(v-html="$icons['upload-white']")
        #stage(
          @dragenter="dragEnter($event)"
          @dragover.stop.prevent="dragOver"
          @dragleave="dragLeave($event)"
          @drop.prevent="drop($event)"
        )
      related-items(ref="relatedItems")
    left-sidebar(
      v-if="!isMobile"
      ref="leftSidebar"
    )
    right-sidebar.right-sidebar

    .backdrop(
      v-if="showBackdrop || rightSidebarShown"
      @click="leftSidebarExpandedSet(false)"
    )

    transition(name="slide-fade" mode="out-in")
      .mobile-action-content(
        v-if="isMobile && showActionContent"
        :class="{ shown: showActionContent, hidden: !showActionContent }"
      )
        actions(:style="{ 'min-width': actionsWidth + 'px' }")
        action-content(
          :style="{ 'width': `calc(100% - ${actionsWidth}px)` }"
          @selected="showActionContent = false"
          @close="showActionContent = false"
        )

    .color-picker-container(
      :class="{ shown: textColorPickerShown, hidden: !textColorPickerShown }"
      ref="colorPickerContainer"
    )
      color-picker(
        :type="colorPickerType"
        @select="changeTextColor"
      )

    transition(name="slide-fade" mode="out-in")
      mobile-main-menu(
        v-if="showMobileMenu"
        @select-size="handleStageSizeChange"
        @close="showMobileMenu = false"
      )

</template>

<script>
import { mapState, mapActions } from 'vuex'
import stageService from '../services/stage'
import itemsService from '../services/items/common'
import textService from '../services/items/text'
import dataService from '../services/data'
import storeService from '../services/store'
import config from '../config'
import AddItemCommand from '../history/commands/addItem'
import TextChangeColorCommand from '../history/commands/text/changeColor'

export default {
  name: 'Project',
  props: {
    collage: {
      type: Object,
      default: null
    },
    template: {
      type: Object,
      default: null
    }
  },
  data () {
    return {
      showActionContent: false,
      showMobileMenu: false,
      textColorPickerShown: false,
      colorPickerType: stageService.TYPE_TEXT_COLOR_PICKER,
      started: false,
      artBoardStyle: {
        width: 'auto'
      },
      workspaceStyle: {
        height: 'auto'
      },
      actionsWidth: config.leftSidebar.actionsWidth,
      showBackdrop: false,
      isFileDragged: false
    }
  },
  computed: {
    ...mapState({
      leftSidebarWidth: state => state.editor.leftSidebarWidth,
      leftSidebarExpanded: state => state.editor.leftSidebarExpanded,
      rightSidebarShown: state => state.editor.rightSidebarShown,
      currentAction: state => state.editor.currentAction,
      isMobile: state => state.editor.isMobile,
      relatedItemsListShown: state => state.editor.related.itemsListShown
    }),
    overlay () {
      let width = 0; let height = 0
      if (stageService.getActualSizesAndPosition()) {
        let actualSize = stageService.getActualSizesAndPosition()
        // + 1 is needed to fix display bugs, meh.
        width = Math.ceil(actualSize.width + 1)
        height = Math.ceil(actualSize.height + 1)
      }
      return {
        width: width + 'px',
        height: height + 'px'
      }
    }
  },
  watch: {
    leftSidebarExpanded () {
      const isWindowNarrow = window.innerWidth < this.actionsWidth + this.leftSidebarWidth + config.artBoardMinWidth
      if (!window.innerWidth > this.actionsWidth + config.artBoardMinWidth) {
        if (!this.leftSidebarExpanded && !isWindowNarrow) {
          this.artBoardStyle.width = `${window.innerWidth - (this.actionsWidth + this.$store.state.editor.leftSidebarWidth)}px)`
        } else {
          this.artBoardStyle.width = `${window.innerWidth - (this.actionsWidth + this.$store.state.editor.leftSidebarWidth)}px)`
        }
      }

      if (!isWindowNarrow) {
        stageService.scale()
      }

      // Show/hide backdrop if window narrow
      if (this.leftSidebarExpanded && isWindowNarrow) {
        this.showBackdrop = true
      } else if (!this.leftSidebarExpanded) {
        this.showBackdrop = false
      }
    },
    textColorPickerShown () {
      // Calculate left and top
      this.$refs.colorPickerContainer.style.top = ''
      if (this.textColorPickerShown) {
        this.$nextTick(() => {
          const activeItem = storeService.get('activeItem')
          const stage = storeService.get('stage')
          const colorPicketTop = config.toolsHeight + activeItem.y() - activeItem.height() / 2
          const leftSidebarWidth = this.leftSidebarExpanded ? this.leftSidebarWidth : 0
          const activeItemHeight = activeItem.height() * activeItem.scaleY()
          const activeItemWidth = activeItem.width() * activeItem.scaleX()
          const colorPickerWidth = this.$refs.colorPickerContainer.offsetWidth
          const colorPickerHeight = this.$refs.colorPickerContainer.offsetHeight

          // Get free spaces up, bottom, left and right around the text
          let top, left
          const leftFreeSpace = activeItem.x() - activeItemWidth / 2 + this.actionsWidth + leftSidebarWidth
          const rightFreeSpace = stage.width() - (activeItem.x() + activeItemWidth / 2 + 60)
          const topFreeSpace = activeItem.y() - activeItemHeight / 2 - 60
          const bottomFreeSpace = stage.height() - activeItem.y() + activeItem.height() / 2 + 5 - (activeItem.y() - activeItem.height() / 2 - 55 < 0 ? 60 : 0)

          // Choose better place for color picker
          top = (colorPicketTop < config.toolsHeight ? config.toolsHeight : colorPicketTop)
          left = this.actionsWidth + leftSidebarWidth + activeItem.x() - activeItemWidth / 2 - 255
          if (leftFreeSpace >= colorPickerWidth) {
          } else if (rightFreeSpace >= colorPickerWidth) {
            left = this.actionsWidth + leftSidebarWidth + activeItem.x() + activeItemWidth / 2 + 60
          } else if (topFreeSpace >= colorPickerHeight) {
            top = activeItem.y() - activeItem.height() / 2 - 60 - colorPickerHeight + config.toolsHeight
            left = this.actionsWidth + leftSidebarWidth + activeItem.x() - activeItemWidth / 2
          } else if (bottomFreeSpace >= colorPickerHeight) {
            left = this.actionsWidth + leftSidebarWidth + activeItem.x() - activeItemWidth / 2
            top = config.toolsHeight + activeItem.y() + activeItem.height() / 2 + 5

            // If text tools are under the text
            if (activeItem.y() - activeItem.height() / 2 - 55 < 0) {
              top += 60
            }
          }

          // Handle height overflow
          if (top + colorPickerHeight > config.toolsHeight + stage.height()) {
            top = config.toolsHeight + stage.height() - colorPickerHeight
          }

          this.$refs.colorPickerContainer.style.top = top + 'px'
          this.$refs.colorPickerContainer.style.left = left + 'px'
        })
      }
    },
    relatedItemsListShown () {
      this.calculateStyles()
    },
    isMobile () {
      if (!this.isMobile) {
        this.showMobileMenu = false
      }
    }
  },
  beforeCreate () {
    storeService.init()
  },
  created () {
  },
  mounted () {
    const leftSidebarWidth = this.leftSidebarExpanded ? config.leftSidebar.minWidth : 0

    storeService.set('rightSidebar', this.$refs.rightSidebar)
    storeService.set('relatedItems', this.$refs.relatedItems)
    storeService.set('toolbar', this.$refs.toolbar)
    storeService.set('textTools', this.$refs.textTools)
    storeService.set('tools', this.$refs.tools)
    storeService.set('ai', this.$refs.ai)
    storeService.set('$photoEditor', this.$el)
    storeService.set('$workspace', this.$refs.workspace)
    storeService.set('$artBoard', this.$refs.artBoard)

    if (!this.isMobile) {
      storeService.get('$artBoard').style.width = this.$el.offsetWidth - leftSidebarWidth - config.leftSidebar.actionsWidth + 'px'
    }

    // Fix 100vh for mobile
    document.documentElement.style.setProperty('--vh', `${window.innerHeight * 0.01}px`)

    window.addEventListener('resize', this.handleWindowResize)
    document.addEventListener('mousedown', this.outsideClick)
    this.$store.dispatch('userCollageSet', this.collage)
    this.loadFonts()
    this.setWindowSizes()
      .then(() => this.start())
  },
  destroyed () {
    this.$store.dispatch('clearStore', null)
    window.removeEventListener('resize', this.handleWindowResize)
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    ...mapActions([
      'fontLoaded',
      'leftSidebarExpandedSet'
    ]),
    start () {
      let startPromise
      if (this.template) {
        startPromise = dataService.restore(this.template.data)
      } else if (this.collage) {
        this.collage.current = true
        startPromise = dataService.restore(this.collage.data)
      } else {
        startPromise = stageService.init({ width: stageService.getDefaultStageSizes().width, height: stageService.getDefaultStageSizes().height })
          .then(() => {
            if (this.$route.query.objects) {
              let objectIds = typeof this.$route.query.objects === 'string' ? [this.$route.query.objects] : this.$route.query.objects
              itemsService.handleItemsByIds(objectIds, itemsService.TYPE_OBJECT)
            }
            if (this.$route.query.models) {
              let modelIds = typeof this.$route.query.models === 'string' ? [this.$route.query.models] : this.$route.query.models
              itemsService.handleItemsByIds(modelIds, itemsService.TYPE_MODEL)
            }
          })
      }

      // Load related to the stage items
      startPromise
        .then(() => {
          itemsService.loadStageItems()
          this.started = true
        })
        .catch(error => {
          this.$store.dispatch('errorsSet', { api: 'Oops... ' + error })
          console.log('Oops... ' + error)
        })
    },
    changeTextColor (color) {
      const activeItem = storeService.get('activeItem')
      if (activeItem) {
        storeService.get('commandManager').execute(new TextChangeColorCommand(activeItem, color))
      }
    },
    dragEnter (event) {
      event.stopPropagation()
      event.preventDefault()
      this.dragging = true
    },
    dragOver (event) {
      if (event.dataTransfer.types.includes('Files')) {
        this.isFileDragged = true
      }
    },
    dragLeave (event) {
      event.stopPropagation()
      event.preventDefault()
      this.dragging = false
      this.isFileDragged = false
    },
    drop (event) {
      if (event.dataTransfer.types.includes('Files')) {
        dataService.handleUploads(event.dataTransfer.files, event)
        this.isFileDragged = false
      } else {
        const itemData = JSON.parse(event.dataTransfer.getData('text/plain'))
        this.dragging = false

        // Calculate mouse offset to place item to the right place
        let params = {}
        if (![itemsService.TYPE_BACKGROUND, itemsService.TYPE_UPLOAD_BACKGROUND].includes(itemData.type)) {
          params.x = event.clientX - storeService.get('$artBoard').offsetLeft
        }
        if (itemData.type === itemsService.TYPE_MODEL) {
          const actualSizesAndPosition = stageService.getActualSizesAndPosition()
          params.y = actualSizesAndPosition.y + actualSizesAndPosition.height - itemData.placeHeight / 2
        }
        if (itemData.type === itemsService.TYPE_OBJECT || itemData.type === itemsService.TYPE_UPLOAD) {
          params.y = event.clientY - config.toolsHeight
        }

        // Adding dragging item to the stage
        storeService.get('commandManager').execute(new AddItemCommand(itemData, params, false, false, true, false))
      }
    },
    loadFonts () {
      if (!this.$store.state.editor.loadedFonts.length) {
        const app = this
        const fontLoaded = []
        WebFont.load({
          fontactive: function (fontTitle) {
            if (!fontLoaded.includes(fontTitle)) {
              app.fontLoaded(config.text.fonts.find(font => font.title === fontTitle))

              // Redraw canvas if text with such a font exists as font is loaded later than text drawn
              textService.handleFontRedraw(fontTitle)

              fontLoaded.push(fontTitle)
            }
          },
          fontinactive: function (fontTitle) {
            console.log('error loading font', fontTitle)
          },
          google: {
            families: config.text.fonts.map(font => `${font.title}:400,700`)
          }
        })
      }
    },
    setWindowSizes () {
      return new Promise(resolve => {
        this.$store.dispatch('setIsMobile', window.innerWidth < config.leftSidebar.actionsWidth + config.artBoardMinWidth || window.innerWidth <= 1024)
        this.$store.dispatch('setIsPortrait', window.innerWidth > window.innerHeight)

        this.$nextTick(() => {
          this.calculateStyles()
          resolve()
        })

        // Fix 100vh for mobile
        document.documentElement.style.setProperty('--vh', `${window.innerHeight * 0.01}px`)
      })
    },
    handleWindowResize () {
      this.setWindowSizes()
        .then(() => {
          if (this.isMobile) {
            stageService.scale()
            setTimeout(() => stageService.scale(), 350)
          } else {
            stageService.scale()
          }
        })
    },
    calculateStyles () {
      // Set art-board width
      const leftSidebarWidth = this.$store.state.editor.leftSidebarExpanded ? this.$store.state.editor.leftSidebarWidth : 0
      if (this.isMobile) {
        this.$refs.artBoard.style.width = window.innerWidth + 'px'
      } else {
        this.$refs.artBoard.style.width = window.innerWidth - config.leftSidebar.actionsWidth - leftSidebarWidth + 'px'
      }

      // Set workspace height
      const relatedPanelHeight = this.isMobile ? this.relatedItemsListShown ? config.relatedPanel.mobileHeight : 0 : config.relatedPanel.desktopHeight
      const workspaceHeight = `calc(100% - ${relatedPanelHeight + 56}px)`
      this.workspaceStyle = {
        height: workspaceHeight,
        'min-height': workspaceHeight
      }
    },
    handleStageSizeChange (size) {
      if (size !== null) {
        this.showMobileMenu = false
      }
    },
    outsideClick (event) {
      const $textProperties = document.querySelector('.text-properties')
      if (
        !this.$refs.workspace.contains(event.target) &&
        !this.$refs.relatedItems.$el.contains(event.target) &&
        !this.$refs.colorPickerContainer.contains(event.target) &&
        !($textProperties && $textProperties.contains(event.target))
      ) {
        stageService.handleOutsideClick()
      }
      const colorPickerButton = document.querySelector('.text-tools .actions .color-picker')
      if (!this.$refs.colorPickerContainer.contains(event.target) && !(colorPickerButton && colorPickerButton.contains(event.target))) {
        this.textColorPickerShown = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import '../assets/css/variables';
  @import '../assets/css/mixins';
  @import '../assets/css/effects';

  .photo-editor {
    width: 100%;
    height: 100vh;
    height: calc(var(--vh, 1vh) * 100);
    display: flex;
    justify-content: flex-end;
    flex-direction: row;
    position: relative;
    background-color: $main-background;
    overflow: hidden;
    transition: 0.5s;

    .backdrop {
      background-color: rgba(0, 0, 0, .5);
      z-index: 20;
    }

    .left-sidebar, .right-sidebar {
      z-index: 30;
    }

    .art-board {
      position: relative;
      z-index: 10;
      display: flex;
      flex-direction: column;
      height: 100vh;
      height: calc(var(--vh, 1vh) * 100);
      transition: height 0.5s;
      background-color: #1a1a1a;

      .workspace {
        width: 100%;
        position: relative;
        z-index: 10;
        justify-content: center;
        align-items: center;
        display: flex;

        .upload-overlay{
          background: rgba(0, 0, 0, .7);
          position: absolute;
          margin: auto;
          pointer-events: none;
          z-index: 50;
          display: flex;
          justify-content: center;
          align-items: center;
          padding: 8px;
          .upload-overlay-inner{
            width: 100%;
            height: 100%;
            border: 2px dashed rgba(255, 255, 255, 0.3);
            border-radius: 10px;
            display: flex;
            justify-content: center;
            align-items: center;
            .icon-wrapper {
              width: 70px;
              height: 70px;
              background: #1A1A1A;
              border-radius: 100%;
              display: flex;
              justify-content: center;
              align-items: center;
              .icon{
                height: 26px;
              }
            }
          }
        }

        #stage {
          position: relative;
          overflow: auto;
        }

        .stage-sizes-container {
          height: 25px;
          position: absolute;
          top: 0;
          z-index: 30;
        }

        /deep/ .dragging-object {
          position: absolute;
          z-index: 20;
        }

        /deep/ .text-edit, /deep/ .text-edit-temp {
          position: absolute;
          background-color: transparent;
          resize: none;
        }
      }

      .related-items {
        z-index: 30;
      }
    }

    .mobile-action-content {
      width: 100%;
      height: 100%;
      position: absolute;
      z-index: 20;
      top: 0;
      display: flex;
      flex-direction: row;
      background-color: $main-background;
    }

    .color-picker-container {
      position: absolute;
      z-index: 30;

      &.shown {
        opacity: 1;
        top: 0;
        transition: top 0.2s, opacity 0.5s;
      }

      &.hidden {
        top: -450px;
        opacity: 0;
        transition: top 0.5s, opacity 0.8s;
      }
    }
  }
</style>
